Bug 1900494

Summary: blender fails to build with Python 3.10: error: implicit declaration of function '_PyUnicode_AsStringAndSize'
Product: [Fedora] Fedora Reporter: Tomáš Hrnčiar <thrnciar>
Component: blenderAssignee: Luya Tshimbalanga <luya_tfz>
Status: NEW --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: design-devel, kwizart, luya_tfz, mhroncok, mtasaka, negativo17, promac, thrnciar
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On:    
Bug Blocks: 1890881    

Description Tomáš Hrnčiar 2020-11-23 08:09:36 UTC
blender fails to build with Python 3.10.0a2.

/python/intern/bpy.c:269:15: error: implicit declaration of function '_PyUnicode_AsStringAndSize'; did you mean 'PyUnicode_FromStringAndSize'? [-Werror=implicit-function-declaration]
  269 |   value_str = _PyUnicode_AsStringAndSize(value, &value_str_len);
      |               ^~~~~~~~~~~~~~~~~~~~~~~~~~
      |               PyUnicode_FromStringAndSize
/builddir/build/BUILD/blender-2.90.1/source/blender/python/intern/bpy.c:269:13: warning: assignment to 'const char *' from 'int' makes pointer from integer without a cast [-Wint-conversion]
  269 |   value_str = _PyUnicode_AsStringAndSize(value, &value_str_len);
      |             ^
cc1: some warnings being treated as errors

bpo-36346: Raises DeprecationWarning for PyUnicode_FromUnicode(NULL, size) and PyUnicode_FromStringAndSize(NULL, size) with size > 0.

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01782561-blender/

For all our attempts to build blender with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/blender/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Mamoru TASAKA 2021-01-18 14:49:29 UTC
Relevant change:
https://github.com/python/cpython/commit/3a8fdb28794b2f19f6c8464378fb8b46bce1f5f4#diff-6be7f081fe6c5e9cbc89323a00399b291d1cda855bcb4c6eeaee0fac89c2f8dd

Probably _PyUnicode_AsStringAndSize should just be changed to PyUnicode_AsUTF8AndSize .

Comment 2 Ben Cotton 2021-02-09 15:26:54 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 3 Mamoru TASAKA 2021-02-12 07:00:28 UTC
Once reported: https://developer.blender.org/T85573